
----
--
----
----missione creata da PVI-Eagle---------------------------------
--
  
------------------------------------------------------------------------------------------------------------------------------------  
-----------------------
--- WAREHOUSE class.

-- Display mission time every 30 seconds.
SCHEDULER:New(nil, UTILS.DisplayMissionTime, {5}, 30, 30)
BASE:E(" --- START WAREHOUSE MISSION ---")

BASE:TraceClass("WAREHOUSE")
BASE:TraceOnOff(true)

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Define Warehouses.
local warehouse={}

--------------------------------------------------------------------------Warehouse KERMAN-------------------------------------------------------------------------------------

--Base KERMAN   
warehouse.KERMAN = WAREHOUSE:New(STATIC:FindByName("Warehouse KERMAN"), "KERMAN") --Functional.Warehouse#WAREHOUSE
warehouse.KERMAN:SetSpawnZone(ZONE:New("KERMAN Spawn Zone"))

warehouse.KERMAN:Start()
warehouse.KERMAN:SetReportOff()
warehouse.KERMAN:AddAsset("CHINA SAM", 2)
warehouse.KERMAN:AddAsset("CHINA SAM 2", 1)
warehouse.KERMAN:AddAsset("CHINA SAM 15", 1)
warehouse.KERMAN:AddAsset("CHINA APC", 10)
warehouse.KERMAN:AddAsset("CHINA TRANSPORT", 10)
warehouse.KERMAN:AddAsset("CHINA TANK", 5)

warehouse.KERMAN:AddRequest(warehouse.KERMAN, WAREHOUSE.Descriptor.GROUPNAME,"CHINA SAM 2", 1, nil, nil, nil, nil)
warehouse.KERMAN:AddRequest(warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_AAA, 1, nil, nil, nil, nil)
--warehouse.KERMAN:__Pause(40)--pausa dopo 40 secondi


--------------------------------------------RICHIESTA DA PARTE DI KERMAN CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local DefenceZone1=ZONE:New("KERMAN POWER PLANT") 

local DefenceZone2=ZONE:New("KERMAN MILITARY BASE") 
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.KERMAN:__AddRequest(time, warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To DefenceZone1") 
  warehouse.KERMAN:__AddRequest(time, warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To DefenceZone1") 
  warehouse.KERMAN:__AddRequest(time, warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To DefenceZone2")
  warehouse.KERMAN:__AddRequest(time, warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To DefenceZone2") 

end

 
-- Take care of the spawned units.
function warehouse.KERMAN:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.KERMAN:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=DefenceZone1:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
 
  elseif assignment=="To DefenceZone2" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=DefenceZone2:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
      end   
     
   end
-- An asset has died ==> request resupply for it.
function warehouse.KERMAN:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem  
  
  -- Get assignment.
  local assignment= warehouse.KERMAN:GetAssignment(request)
  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
 warehouse.KERMAN:AddRequest(warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 

end

--------------------------------------------------------------------Warehouse JIROFT-------------------------------------------------------------------------------------------------------

--Base JIROFT   
warehouse.JIROFT = WAREHOUSE:New(STATIC:FindByName("Warehouse JIROFT"), "JIROFT") --Functional.Warehouse#WAREHOUSE
warehouse.JIROFT:SetSpawnZone(ZONE:New("JIROFT Spawn Zone"))
warehouse.JIROFT:SetPortZone(ZONE_POLYGON:NewFromGroupName("JIROFT Port Zone", "JIROFT Port Zone"))

warehouse.JIROFT:Start()
--warehouse.JIROFT:SetReportOff()
warehouse.JIROFT:AddAsset("CHINA SAM", 1)
warehouse.JIROFT:AddAsset("CHINA SAM 15", 1)
warehouse.JIROFT:AddAsset("CHINA APC", 10)
warehouse.JIROFT:AddAsset("CHINA TRANSPORT", 10)
warehouse.JIROFT:AddAsset("CHINA TANK", 5)
warehouse.JIROFT:AddAsset("CHINA DESTROYER", 1, WAREHOUSE.Attribute.NAVAL_WARSHIP)
warehouse.JIROFT:AddAsset("CHINA FRIGATE", 1, WAREHOUSE.Attribute.NAVAL_WARSHIP)



warehouse.JIROFT:AddRequest(warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, nil)
warehouse.JIROFT:AddRequest(warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, nil)
warehouse.JIROFT:AddRequest(warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, nil) 

--warehouse.JIROFT:__Pause(40)--pausa dopo 40 secondi




--------------------------------------------RICHIESTA DA PARTE DI JIROFT CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local DefenceZone1=ZONE:New("DEFENCEZONE1") 

local DefenceZone2=ZONE:New("DEFENCEZONE2") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.JIROFT:__AddRequest(time, warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To DefenceZone1") 
  warehouse.JIROFT:__AddRequest(time, warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To DefenceZone1") 
  warehouse.JIROFT:__AddRequest(time, warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To DefenceZone2") 

end

 
-- Take care of the spawned units.
function warehouse.JIROFT:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.JIROFT:GetAssignment(request)
  
  if assignment=="To DefenceZone1" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=DefenceZone1:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
      
  elseif assignment=="To DefenceZone2" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=DefenceZone2:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
      end   
     
   end

-- An asset has died ==> request resupply for it.
function warehouse.JIROFT:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment= warehouse.JIROFT:GetAssignment(request)
  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
 warehouse.JIROFT:AddRequest(warehouse.KERMAN, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 

end

--------------------------------------------------------------------Warehouse BANDAR_E_JASK-------------------------------------------------------------------------------------------------------

--Base BANDAR_E_JASK   
warehouse.BANDAR_E_JASK = WAREHOUSE:New(STATIC:FindByName("Warehouse BANDAR_E_JASK"), "BANDAR_E_JASK") --Functional.Warehouse#WAREHOUSE
warehouse.BANDAR_E_JASK:SetSpawnZone(ZONE_POLYGON:New("BANDAR_E_JASK Spawn Zone", GROUP:FindByName("BANDAR_E_JASK Spawn Zone")))
warehouse.BANDAR_E_JASK:SetPortZone(ZONE_POLYGON:NewFromGroupName("BANDAR_E_JASK Port Zone", "BANDAR_E_JASK Port Zone"))
warehouse.BANDAR_E_JASK:Start()
warehouse.BANDAR_E_JASK:AddShippingLane(warehouse.JIROFT, GROUP:FindByName("Shipping_Lane_1"))
warehouse.BANDAR_E_JASK:AddShippingLane(warehouse.JIROFT, GROUP:FindByName("Shipping_Lane_2"))
--warehouse.BANDAR_E_JASK:SetReportOff()
warehouse.BANDAR_E_JASK:AddAsset("CHINA SAM", 1)
warehouse.BANDAR_E_JASK:AddAsset("CHINA SAM 15", 1)
warehouse.BANDAR_E_JASK:AddAsset("CHINA APC", 10)
warehouse.BANDAR_E_JASK:AddAsset("CHINA TRANSPORT", 10)
warehouse.BANDAR_E_JASK:AddAsset("CHINA TANK", 5)
warehouse.BANDAR_E_JASK:AddAsset("CHINA DESTROYER", 1, WAREHOUSE.Attribute.NAVAL_WARSHIP)
warehouse.BANDAR_E_JASK:AddAsset("CHINA FRIGATE", 1, WAREHOUSE.Attribute.NAVAL_WARSHIP)


warehouse.BANDAR_E_JASK:AddRequest(warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, nil)
warehouse.BANDAR_E_JASK:AddRequest(warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, nil)
warehouse.BANDAR_E_JASK:AddRequest(warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, nil) 

--warehouse.BANDAR_E_JASK:__Pause(40)--pausa dopo 40 secondi




--------------------------------------------RICHIESTA DA PARTE DI BANDAR_E_JASK CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("BANDAR_E_JASK NAVAL BASE") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.JIROFT:__AddRequest(time, warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.NAVAL_WARSHIP, 1, nil, nil, nil, "ship")
  warehouse.BANDAR_E_JASK:__AddRequest(time, warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.BANDAR_E_JASK:__AddRequest(time, warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.BANDAR_E_JASK:__AddRequest(time, warehouse.BANDAR_E_JASK, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone") 

end

 
-- Take care of the spawned units.
function warehouse.BANDAR_E_JASK:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.BANDAR_E_JASK:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
      
  elseif assignment=="ship" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      group:GetSpeedMax():InitAIOn()  
      group:OptionAlarmStateRed()
    end
        
      end   
     
   end

-- An asset has died ==> request resupply for it.
function warehouse.BANDAR_E_JASK:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment= warehouse.BANDAR_E_JASK:GetAssignment(request)
  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
 warehouse.BANDAR_E_JASK:AddRequest(warehouse.JIROFT, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 

end

--------------------------------------------------------------------------Warehouse FARP-------------------------------------------------------------------------------------

--Base FARP   
warehouse.FARP = WAREHOUSE:New(STATIC:FindByName("Warehouse FARP"), "FARP") --Functional.Warehouse#WAREHOUSE
warehouse.FARP:SetSpawnZone(ZONE:New("FARP Spawn Zone"))

warehouse.FARP:Start()
--warehouse.FARP:SetReportOff()
warehouse.FARP:AddAsset("CHINA HELOS 2", 4, WAREHOUSE.Attribute.AIR_ATTACKHELO)
warehouse.FARP:AddAsset("CHINA HELOS", 4, WAREHOUSE.Attribute.AIR_ATTACKHELO)
warehouse.FARP:AddAsset("CHINA TRANSPORT", 4)
--warehouse in pausa dopo 25 secondi
warehouse.FARP:__Pause(25)
--warehouse riprende dopo 45 minuti
warehouse.FARP:__Unpause(2700)

warehouse.FARP:AddRequest(warehouse.FARP, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_AAA, 1, nil, nil, nil, nil)



--------------------------------------------RICHIESTA DA PARTE DI FARP CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.FARP:__AddRequest(time, warehouse.FARP, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_ATTACKHELO, 1, nil, nil, nil, "BAI1")
  warehouse.FARP:__AddRequest(time, warehouse.FARP, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_ATTACKHELO, 1, nil, nil, nil, "BAI2")

end
 
-- Take care of the spawned units.
function warehouse.FARP:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.FARP:GetAssignment(request)
  
  
 ----------------------------------------------------------------------------------------BAI1-------------------------------------------------------------------------------------------------------------

  if assignment=="BAI1" then
    
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "Artillery1_ZONE" )
       
       local BAI1=AI_BAI_ZONE:New(ZONE:New("HELO_Patrolzone1"), 500, 1000, 500, 600, BAIEngagementZone)
       
  --      targets assegnati agli Helos in DCS FMB
       local Targets1 = GROUP:FindByName("Artillery 1")
       
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI1:SetControllable(group)          
                     
           -- Start BAI
           BAI1:Start()
           
           -- Engage after 3 minuts
           BAI1:__Engage(180)
          
          -- RTB after 30 min max.
          BAI1:__RTB(18000)  
          BAI1:InitCleanUp( 180 )
          BAI1:InitRepeatOnEngineShutDown()



 
     
  ---------------------------------------------------------------------------------BAI2-------------------------------------------------------------------------------------------------------------------          

  elseif assignment=="BAI2" then
    
        
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "Artillery2_ZONE" )
       
       local BAI2=AI_BAI_ZONE:New(ZONE:New("HELO_Patrolzone2"), 500, 1000, 500, 600, BAIEngagementZone)
       
  --      targets assegnati agli Helos in DCS FMB        
       local Targets2 = GROUP:FindByName("Artillery 2")
       
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI2:SetControllable(group)
          
                    
           -- Start BAI
           BAI2:Start()
           
           -- Engage after 3 minuts
           BAI2:__Engage(180)
          
          -- RTB after 30 min max.
          BAI2:__RTB(18000)  
          BAI2:InitCleanUp( 180 )   
          BAI2:InitRepeatOnEngineShutDown()
           

  
  end

  end
  
  -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  --
  --
-- An asset has died ==> request resupply for it.
function warehouse.FARP:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem  
  
  -- Get assignment.
  local assignment= warehouse.FARP:GetAssignment(request)
  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
 warehouse.FARP:AddRequest(warehouse.FARP, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 

end